function fn(requestPath, queryParamMap, properties) {

  var ret = {
    data: []
  };

  var connProductName = queryParamMap.webServiceConnectionProductName;
  var connName = queryParamMap.webServiceConnectionName;
  var storageDeviceId = queryParamMap.storageDeviceId;

  if (!connProductName || !connName || !storageDeviceId) {
    return ret;
  }

  // get session
  var objClient = ConfigurationManager._01_62_00.api.ObjectsApi();
  var viewClient = ConfigurationManager._01_62_00.api.ViewsApi();
  env.setWebServiceConnection(objClient, connProductName, connName, '/ConfigurationManager');
  env.setWebServiceConnection(viewClient, connProductName, connName, '/ConfigurationManager');

  var session = objClient.v1.objects.storages.storageDeviceID.sessions.post(storageDeviceId, null, null, null);
  var token = session.getToken();
  var sId = session.getSessionId();

  viewClient.getApiClient().setApiKeyPrefix("Session");
  viewClient.getApiClient().setApiKey(token);

  // get Volumes

  // storage query
  var query = String('ldev.storageDeviceId eq ' + storageDeviceId);
  var orderBy = 'ldev.ldevId ASC';

  // filter query
  if (queryParamMap.filter) {
    try {
      var filters = JSON.parse(decodeURIComponent(queryParamMap.filter));
      var join = queryParamMap.filterJoinType;
      if (join != 'and' && join != 'or') {
        join = 'and';
      }
      var filterQuery = '';
      for (var i = 0; i < filters.length; i++) {
        var filter = filters[i];
        if (filter.field && filter.operator && filter.value !== null && filter.value !== undefined && !(filter.field != 'label' && filter.value === '')) {
          if (filterQuery) {
            filterQuery = String(filterQuery + ' ' + join + ' ');
          }
          var val = filter.value;
          var field = filter.field;
          if (filter.field == 'label') {
            // string value
            val = val.replace(/'/g, "''");
            val = String("'" + val + "'");
          } if (filter.field == 'ldevIdHex') {
            field = "ldevId";
            if (/^[0-9A-Fa-f]+$/.test(val) || !isNaN(val)) {
              val = parseInt(val, 16);
            } else if (/^([0-9a-fA-F]{2}:){0,2}[0-9a-fA-F]{2}$/.test(val)) {
              val = parseInt(val.replace(/:/g, ""), 16);
            } else {
              continue;
            }
          } if (filter.field == 'ldevId' || filter.field == 'poolId') {
            if (!/^[0-9]+$/.test(val)) {
              continue;
            }
          }
          filterQuery = String(filterQuery + 'ldev.' + field + ' ' + filter.operator + ' ' + val);
        }
      }
      if (filterQuery) {
        query = String(query + ' and (' + filterQuery + ')');
      }
    } catch (e) {
    }
  }

  query = encodeURIComponent(query);

  try {
    var result = viewClient.v1.views.lunPaths.get(query, 0, 1000, null, orderBy, null, null).getData();
    var ldevIds = [];
    for (var i = 0; i < result.length; i++) {
      var ldev = result[i].getLdev();
      if (ldev.getPoolId() !== null && !_.contains(ldevIds, ldev.getLdevId())) {
        ret.data.push(ldev);
        ldevIds.push(ldev.getLdevId());
        var capacity = ldev.getByteFormatCapacity();
        if (capacity && /[KMGT]$/.test(capacity)) {
          ldev['byteFormatCapacity'] = capacity + 'iB';
        }
      }
    }
  } finally {
    try {
      var body = new ConfigurationManager._01_62_00.model.SESSIONREQUESTSESSIONDELETEREQUEST();
      objClient.v1.objects.storages.storageDeviceID.sessions.sessionId.delete(storageDeviceId, String(session.getSessionId()), body, null, null);
    } catch (e) {
      print(e);
    }
  }

  return ret;
}
