function fn(requestPath, queryParamMap, properties) {

  var ret = {
    data: []
  };

  var connProductName = queryParamMap.webServiceConnectionProductName;
  var connName = queryParamMap.webServiceConnectionName;
  var storageDeviceId = queryParamMap.storageDeviceId;

  if (!connProductName || !connName || !storageDeviceId) {
    return ret;
  }

  // get session
  var objClient = ConfigurationManager._01_62_00.api.ObjectsApi();
  env.setWebServiceConnection(objClient, connProductName, connName, '/ConfigurationManager');

  var session = objClient.v1.objects.storages.storageDeviceID.sessions.post(storageDeviceId, null, null, null);
  var token = session.getToken();
  var sId = session.getSessionId();

  objClient.getApiClient().setApiKeyPrefix("Session");
  objClient.getApiClient().setApiKey(token);

  // get Pools
  try {
    var result = objClient.v1.objects.storages.storageDeviceID.pools.get(
      storageDeviceId,
      null,
      'DP',
      null,
      null
    ).getData();
    for (var i = 0; i < result.length; i++) {
      var pool = result[i];
      ret.data.push({
        poolId: pool.getPoolId(),
        poolName: pool.getPoolName(),
        poolType: pool.getPoolType(),
        usedCapacityRate: pool.getUsedCapacityRate(),
        availableVolumeCapacity: pool.getAvailableVolumeCapacity(),
        totalPoolCapacity: pool.getTotalPoolCapacity(),
        numOfLdevs: pool.getNumOfLdevs()
      });
    }
  } finally {
    try {
      var body = new ConfigurationManager._01_62_00.model.SESSIONREQUESTSESSIONDELETEREQUEST();
      objClient.v1.objects.storages.storageDeviceID.sessions.sessionId.delete(storageDeviceId, String(session.getSessionId()), body, null, null);
    } catch (e) {
      print(e);
    }
  }

  return ret;
}

