function fn(requestPath, queryParamMap, properties) {
  var ret = {
    data: []
  };

  if (!queryParamMap.connection_product_name || !queryParamMap.connection_name) {
    return ret;
  }

  var client = ConfigurationManager._01_62_00.api.ObjectsApi();
  env.setWebServiceConnection(client, queryParamMap.connection_product_name, queryParamMap.connection_name, '/ConfigurationManager');


  try {
    var storageSystems = client.v1.objects.storages.get(null, null).getData();
    var modifiedStorageSystems = _.map(storageSystems, function (storage) {
      var modifiedStorage = {
        storageDeviceId: storage.getStorageDeviceId(),
        model: storage.getModel(),
        serialNumber: storage.getSerialNumber(),
        svpIp: "-",
        ctl1Ip: "-",
        ctl2Ip: "-",
        targetCtl: "-"
      };
      if (storage.getSvpIp()) {
        modifiedStorage.svpIp = storage.getSvpIp();
      }
      if (storage.getCtl1Ip()) {
        modifiedStorage.ctl1Ip = storage.getCtl1Ip();
      }
      if (storage.getCtl2Ip()) {
        modifiedStorage.ctl2Ip = storage.getCtl2Ip();
      }
      if (storage.getTargetCtl()) {
        modifiedStorage.targetCtl = storage.getTargetCtl();
      }
      return modifiedStorage;
    });

    ret.data = modifiedStorageSystems;
    return ret;
  } catch (e) {
    print("Failed to access to Configuration Manager.(" + e + ")");
  }
  return ret;
}