function fn(requestPath, queryParamMap, properties) {
    var ret = {
        data: []
    };

    if (!queryParamMap.connection_product_name ||
        !queryParamMap.connection_name ||
        !queryParamMap.storage_device_id) {
        return ret;
    }

    var client = ConfigurationManager._01_62_00.api.ObjectsApi();
    var session = null;
    env.setWebServiceConnection(client, queryParamMap.connection_product_name, queryParamMap.connection_name, '/ConfigurationManager');

    try {
        session = client.v1.objects.storages.storageDeviceID.sessions.post(queryParamMap.storage_device_id, null, null, null);
        var token = session.getToken();

        client.getApiClient().setApiKeyPrefix("Session");
        client.getApiClient().setApiKey(token);

        var resourceGroups = client.v1.objects.storages.storageDeviceID.resourceGroups.get({"storageDeviceID": queryParamMap.storage_device_id}).getData();
        for (var i = 0; i < resourceGroups.length; i++) {
        	var rg = resourceGroups[i];
        	ret.data.push(rg);
        }
    } catch (e) {
        print("Failed to access to Configuration Manager.(" + e + ")");
    } finally {
        try {
            var body = new ConfigurationManager._01_62_00.model.SESSIONREQUESTSESSIONDELETEREQUEST();
            if (session !== null) {
                client.v1.objects.storages.storageDeviceID.sessions.sessionId.delete(queryParamMap.storage_device_id, String(session.getSessionId()), body, null, null);
            }
        } catch (e) {
            print("Failed to delete the session for Configuration Manager.(" + e + ")");
        }
    }
    return ret;
}
